"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactHookForm = require("react-hook-form");

var _TextField = _interopRequireDefault(require("./TextField"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const FormTextField = /*#__PURE__*/_react.default.forwardRef((props, ref) => {
  const {
    name,
    rules,
    validationLength = 1,
    formatter,
    onBlur,
    onValid,
    ...restOfProps
  } = props;
  const {
    control,
    errors,
    trigger,
    watch
  } = (0, _reactHookForm.useFormContext)();
  const value = watch(name);
  (0, _react.useEffect)(() => {
    async function validate() {
      const isValid = await trigger(name);
      if (isValid) onValid === null || onValid === void 0 ? void 0 : onValid();
    }

    if (value.length >= validationLength) {
      validate();
    }
  }, [value, name, validationLength, trigger]); // eslint-disable-line react-hooks/exhaustive-deps

  return /*#__PURE__*/_react.default.createElement(_reactHookForm.Controller, {
    control: control,
    render: ({
      onChange,
      onBlur: onBlurLocal,
      value: newValue
    }) => {
      var _errors$name;

      return /*#__PURE__*/_react.default.createElement(_TextField.default // passing everything down to TextField
      // to be able to support all TextInput props
      , _extends({}, restOfProps, {
        ref: ref,
        testID: "TextField.".concat(name),
        errorText: (_errors$name = errors[name]) === null || _errors$name === void 0 ? void 0 : _errors$name.message,
        onBlur: event => {
          onBlurLocal();
          onBlur === null || onBlur === void 0 ? void 0 : onBlur(event);
        },
        onChangeText: text => {
          const formatted = formatter ? formatter(newValue, text) : text;
          onChange(formatted);
        },
        value: newValue
      }));
    },
    name: name,
    rules: rules
  });
});

var _default = FormTextField;
exports.default = _default;
//# sourceMappingURL=FormTextField.js.map